## hkl-pseudoaxis-auto-private

hkl-pseudoaxis-auto-private

## Functions

#define | CHECK_NAN()
#define | HKL_MODE_AUTO_INFO()
#define | HKL_MODE_AUTO_INFO_WITH_PARAMS()
HklMode * | hkl_mode_auto_new ()
void | hkl_mode_auto_init ()
int | hkl_mode_auto_set_real ()
GQuark | hkl_mode_auto_with_init_error_quark ()
HklMode * | hkl_mode_auto_with_init_new ()

## Types and Values

struct | HklFunction
typedef | darray_function
struct | HklModeAutoInfo
#define | HKL_MODE_OPERATIONS_AUTO_DEFAULTS
struct | HklModeAutoWithInit
#define | HKL_MODE_AUTO_WITH_INIT_ERROR
enum | HklModeError
#define | HKL_MODE_OPERATIONS_AUTO_WITH_INIT_DEFAULTS
HklModeAutoWithInit * | self

## Description

## Functions

### CHECK_NAN()

    #define             CHECK_NAN(x, len)

### HKL_MODE_AUTO_INFO()

    #define HKL_MODE_AUTO_INFO(_name, _axes_r, _axes_w, _fn) .info={HKL_MODE_INFO(_name, _axes_r, _axes_w),}, .functions=DARRAY(_fn)

### HKL_MODE_AUTO_INFO_WITH_PARAMS()

    #define HKL_MODE_AUTO_INFO_WITH_PARAMS(_name, _axes_r, _axes_w, _fn, _parameters) .info={HKL_MODE_INFO_WITH_PARAMS(_name, _axes_r, _axes_w, _parameters)}, .functions=DARRAY(_fn)

### hkl_mode_auto_new ()

    HklMode *
    hkl_mode_auto_new (const HklModeAutoInfo *auto_info,
                       const HklModeOperations *ops,
                       int initialized);

### hkl_mode_auto_init ()

    void
    hkl_mode_auto_init (HklMode *self,
                        const HklModeAutoInfo *auto_info,
                        const HklModeOperations *ops,
                        int initialized);

### hkl_mode_auto_set_real ()

    int
    hkl_mode_auto_set_real (HklMode *self,
                            HklEngine *engine,
                            HklGeometry *geometry,
                            HklDetector *detector,
                            HklSample *sample,
                            GError **error);

### hkl_mode_auto_with_init_error_quark ()

    GQuark
    hkl_mode_auto_with_init_error_quark (void);

### hkl_mode_auto_with_init_new ()

    HklMode *
    hkl_mode_auto_with_init_new (const HklModeAutoInfo *info,
                                 const HklModeOperations *ops,
                                 int initialized);

## Types and Values

### struct HklFunction

    struct HklFunction {
    	const uint size;
    	int (* function) (const gsl_vector *x, void *params, gsl_vector *f);
    };

### darray_function

    typedef darray(const HklFunction*) darray_function;

### struct HklModeAutoInfo

    struct HklModeAutoInfo {
    	const HklModeInfo info;
    	darray_function functions;
    };

### HKL_MODE_OPERATIONS_AUTO_DEFAULTS

    #define             HKL_MODE_OPERATIONS_AUTO_DEFAULTS

### struct HklModeAutoWithInit

    struct HklModeAutoWithInit {
    	HklMode mode;
    	HklGeometry *geometry;
    	HklDetector *detector;
    	HklSample *sample;
    };

### HKL_MODE_AUTO_WITH_INIT_ERROR

    #define HKL_MODE_AUTO_WITH_INIT_ERROR hkl_mode_auto_with_init_error_quark ()

### enum HklModeError

#### Members

HKL_MODE_AUTO_WITH_INIT_ERROR_INIT |  |

### HKL_MODE_OPERATIONS_AUTO_WITH_INIT_DEFAULTS

    #define             HKL_MODE_OPERATIONS_AUTO_WITH_INIT_DEFAULTS

### self

    	HklModeAutoWithInit *self = container_of(mode, HklModeAutoWithInit, mode);